﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using System.Web;
using Microsoft.WindowsAzure;
using Microsoft.WindowsAzure.Storage;
using Microsoft.WindowsAzure.Storage.Queue;


public static class StorageHelper
{
    private static readonly CloudStorageAccount StorageAccount;
    private static readonly CloudQueueClient QueueClient;
    private static readonly CloudQueue UploadQueue;
    private static readonly CloudQueue LikeQueue;
    static StorageHelper()
    {
        StorageAccount = CloudStorageAccount.Parse(CloudConfigurationManager.GetSetting("StorageConnectionString"));
        QueueClient = StorageAccount.CreateCloudQueueClient();
        UploadQueue = QueueClient.GetQueueReference("uploadqueue");
        LikeQueue = QueueClient.GetQueueReference("likequeue");
        UploadQueue.CreateIfNotExists();
        LikeQueue.CreateIfNotExists();
    }

    public static Task EnqueueUploadAsync(string userName, string galleryId, string imageId, string imageExtension)
    {
        return UploadQueue.AddMessageAsync(new CloudQueueMessage(String.Format("{0}, {1}, {2}, {3}", userName, galleryId, imageId, imageExtension)));
    }

    public static Task EnqueueLikeAsync(string userName, string imageId)
    {
        return LikeQueue.AddMessageAsync(new CloudQueueMessage(String.Format("{0}, {1}", userName, imageId)));
    }
}