﻿using System;
using System.Collections.Generic;
using System.Configuration;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Microsoft.WindowsAzure.Storage;
using Microsoft.WindowsAzure.Storage.Auth;
using Microsoft.WindowsAzure.Storage.Blob;

namespace ImageUploadAndProcessingJob
{
    public static class RemoteStorageManager
    {
        private static CloudStorageAccount sourceAccount;
        private static CloudBlobClient sourceBlobClient;
        private static CloudStorageAccount targetAccount;
        private static CloudBlobClient targetBlobClient;

        static RemoteStorageManager()
        {
            if (ConfigurationManager.ConnectionStrings["AzureJobsRuntime"] != null &&
                ConfigurationManager.ConnectionStrings["RemoteAzureStorage"] != null)
            {
                sourceAccount =
                    CloudStorageAccount.Parse(
                        ConfigurationManager.ConnectionStrings["AzureJobsRuntime"].ConnectionString);
                sourceBlobClient = sourceAccount.CreateCloudBlobClient();
                targetAccount =
                    CloudStorageAccount.Parse(
                        ConfigurationManager.ConnectionStrings["RemoteAzureStorage"].ConnectionString);
                targetBlobClient = targetAccount.CreateCloudBlobClient();
            }
        }

        public static void ReplicateBlob(string container, string blob)
        {
            if (sourceBlobClient == null || targetBlobClient == null)
                return;
            var sourceContainer = sourceBlobClient.GetContainerReference(container);
            var targetContainer = targetBlobClient.GetContainerReference(container);
            if (targetContainer.CreateIfNotExists())
            {
                targetContainer.SetPermissions(sourceContainer.GetPermissions());
            }
            var targetBlob = targetContainer.GetBlockBlobReference(blob);
            targetBlob.StartCopyFromBlob(sourceContainer.GetBlockBlobReference(blob));
        }
    }
}
